


--[[
local BBarObjects_Points = {395, 396, 392, 390};
local BBarObjects_Professions = {61, 361, 698, 402, 81};
local BBarObjects_Items = {515, 241, 416, 391, 614, 615, 697};
local BBarObjects_Archaeology = {384, 398, 394, 385, 397, 393, 400, 401, 676, 677};

390 = Conquest Points
392 = Honor Points
395 = Justice Points
396 = Valor Points

61 = Dalaran Jewelcrafter's Token
361 = Illustrious Jewelcrafter's Token
698 = Zen Jewelcrafter's Token
402 = Ironpaw Token
81 = Epicurean's Award

515 = Darkmoon Prize Ticket
241 = Champion's Seal
416 = Mark of the World Tree
391 = Tol Barad Commendation
614 = Mote of Darkness
615 = Essence of Corrupted Deathwing
697 = Elder Charm of Good Fortune

384 = Dwarf Archaeology Fragment
398 = Draenei Archaeology Fragment
394 = Night Elf Archaeology Fragment
385 = Troll Archaeology Fragment
397 = Orc Archaeology Fragment
393 = Fossil Archaeology Fragment
399 = Vrykul Archaeology Fragment
400 = Nerubian Archaeology Fragment
401 = Tol'vir Archaeology Fragment
676 = Pandaren Archaeology Fragment
677 = Mogu Archaeology Fragment
]]--

----------------------------------------------
-- Functions
----------------------------------------------


function BBar_ToggleMoving(self)

	g_BBar.BBarTitleRegion:ClearAllPoints();
	if(self:GetChecked()) then
		g_BBar.BBarTitleRegion:SetPoint("TOP", UIParent, 0, math.huge);	-- Disable Moving
		BBarWindowLock = 1;
	else
		g_BBar.BBarTitleRegion:SetAllPoints();	-- Enable moving
		BBarWindowLock = 0;
	end
end


function BBar_ToggleTooltips(self)

	if(self:GetChecked()) then
		BBarShowTooltip = 1;
	else
		BBarShowTooltip = 0;
	end
end


function BBarTab_OnClick(id)

	g_BBar.CurrentSettingsTab = id;
	if(g_BBar.CurrentSettingsTab == 1) then		-- Currencies
		_G["BBarSettingsFrameTab1"]:SetChecked(1);
		_G["BBarSettingsFrameTab2"]:SetChecked(nil);

		g_BBar.RepScrollFrame:Hide();
		_G["BBarSettingsFrameScrollBack"]:SetSize(353, 348);
		_G["BBarSettingsFrameDropArea"]:Show();
		g_BBar.CurrencyScrollFrame:Show();
	else										-- Reputations
		_G["BBarSettingsFrameTab1"]:SetChecked(nil);
		_G["BBarSettingsFrameTab2"]:SetChecked(1);

		_G["BBarSettingsFrameDropArea"]:Hide();
		g_BBar.CurrencyScrollFrame:Hide();
		_G["BBarSettingsFrameScrollBack"]:SetSize(353, 373);
		g_BBar.RepScrollFrame:Show();
	end
end


function BBar_SettingsCheckOnClick(self)

	local obj = self:GetParent();
	if(obj.positionID < 100) then
		if(self:GetChecked()) then	g_BBar.BBarObjects_Shown[obj.positionID] = 1;
		else						g_BBar.BBarObjects_Shown[obj.positionID] = 0;
		end
	else
		if(self:GetChecked()) then	g_BBar.BBarObjectsItems_Shown[obj.positionID - 100] = 1;
		else						g_BBar.BBarObjectsItems_Shown[obj.positionID - 100] = 0;
		end
	end
	BBar_UpdateBar();
	ValuesToString();	-- Store changes
end


function BBar_SettingsRemoveOnClick(self)

	local iPos = self:GetParent().positionID - 100;

	-- Remove it from the bar while it's still valid
	g_BBar.BBarObjectsItems_Shown[iPos] = 0;
	BBar_UpdateBar();

	-- Remove it completly
	g_BBar.BBarObjectsItems[iPos] = 0;
	BBar_UpdateSettings(_G["BBarSettingsFrame"]);
	ValuesToString();	-- Store changes
end


function BBar_SettingsRepShowOnClick(self)

	local obj = self:GetParent();
	if(self:GetChecked()) then
		g_BBar.BBarObjectsReps_Faction[obj.pos] = {obj.factionID, 1};
	else
		g_BBar.BBarObjectsReps_Faction[obj.pos][2] = 0;
	end
	BBar_UpdateBar();
	ValuesToString();	-- Store changes
end


function BBar_ShowInfoTooltip(self)

	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT");
	GameTooltip:AddDoubleLine("BBar", "[ Made by Bynun ]", 0.9, 0.7, 0.1, 0.2, 1 ,0.2)

	_, g_BBar.TooltipStorage[1] = GameTooltipTextLeft1:GetFont();
	g_BBar.TooltipStorage[2] = GameTooltipTextLeft1:GetHeight();
	GameTooltipTextLeft1:SetFont(GameTooltipTextLeft1:GetFont(), 18);
	GameTooltipTextLeft1:SetHeight(24);

	_, g_BBar.TooltipStorage[3] = GameTooltipTextRight1:GetFont();
	g_BBar.TooltipStorage[4], _, _, g_BBar.TooltipStorage[5], g_BBar.TooltipStorage[6] = GameTooltipTextRight1:GetPoint(1);
	GameTooltipTextRight1:SetFont(GameTooltipTextRight1:GetFont(), 11);
	GameTooltipTextRight1:SetPoint("TOPRIGHT", -16, -14);

	GameTooltip:AddLine("|cffffffff::|r |cff44ff44/bbar|r Reset the bars position to the center of the screen.", 0.8, 0.8, 0.8);
	GameTooltip:AddLine("|cffffffff::|r Drag an item from your bag to the settings window to add it as a new currency.",  0.8, 0.8, 0.8);
	GameTooltip:AddLine("   You can then view that item's count on the main bar.",  0.8, 0.8, 0.8);
	GameTooltip:AddLine("|cffffffff::|r You can display an unlimited number of items",  0.8, 0.8, 0.8);
	GameTooltip:AddLine("|cffffffff::|r Item count includes all bag and bank items of that type.",  0.8, 0.8, 0.8);
	GameTooltip:Show();
end

function BBar_HideInfoTooltip(self)

	GameTooltip:Hide();

	-- Set it all back again
	GameTooltipTextLeft1:SetFont(GameTooltipTextLeft1:GetFont(), g_BBar.TooltipStorage[1]);
	GameTooltipTextLeft1:SetHeight(g_BBar.TooltipStorage[2]);
	GameTooltipTextRight1:SetFont(GameTooltipTextRight1:GetFont(), g_BBar.TooltipStorage[3]);
	GameTooltipTextRight1:SetPoint(g_BBar.TooltipStorage[4], g_BBar.TooltipStorage[5], g_BBar.TooltipStorage[6]);
	
	GameTooltip:ClearLines();
end


function BBar_AcceptItem(infoType, itemID)

	-- Add the item to the custom items list
	if(infoType == "item") then
		-- Check it's not already added
		for i = 1, getn(g_BBar.BBarObjectsItems), 1 do
			if(g_BBar.BBarObjectsItems[i] == itemID) then
				ClearCursor();
				return;
			end
		end

		-- Add it to the end of the list
		local iPos = getn(g_BBar.BBarObjectsItems) + 1;
		g_BBar.BBarObjectsItems[iPos] = itemID;
		g_BBar.BBarObjectsItems_Shown[iPos] = 1;	-- Shown as default
		ClearCursor();
		BBar_UpdateBar();
		BBar_UpdateSettings(_G["BBarSettingsFrame"]);
		ValuesToString();	-- Store changes
	end
end


function BBar_HandleModifiedItemClick(link)

	if(IsAltKeyDown()) then
		local justID = string.gsub(link,".-\124H([^\124]*)\124h.*", "%1")
		local infoType, itemID = strsplit(":",justID);	-- enchantId, jewelId1, jewelId2, jewelId3, jewelId4, suffixId, uniqueId, linkLevel, reforgeId = strsplit(":",justID)
		local itemName, _, itemQuality = GetItemInfo(itemID);

		if(infoType == "item") then	-- Ask if it should be added
			_G["BBarAddItem"].infoType = infoType;
			_G["BBarAddItem"].itemID = tonumber(itemID);
			_G["BBarAddItemItem"]:SetText(itemName);
			_G["BBarAddItemItem"]:SetTextColor(GetItemQualityColor(itemQuality));
			_G["BBarAddItemIcon"]:SetTexture(GetItemIcon(itemID));
			_G["BBarAddItem"]:Show();
		end
	end
end


---------------------------


function BBar_BuildSettingsFrame()		-- Create the settings window, only called once

	-- Reputation scroll window
	g_BBar.RepScrollFrame = CreateFrame("ScrollFrame", "RepScrollFrame", _G["BBarSettingsFrame"], "UIPanelScrollFrameTemplate");
	g_BBar.RepScrollFrame:SetPoint("TOPLEFT", _G["BBarSettingsFrame"], "TOPLEFT", 14, -80);
	g_BBar.RepScrollFrame:SetPoint("BOTTOMRIGHT", _G["BBarSettingsFrame"], "BOTTOMRIGHT", -31, 12);

	local scrollChild = CreateFrame("Frame", "BBarScrollFrameChildRep", g_BBar.RepScrollFrame);
	scrollChild:EnableMouse(true)
	scrollChild:SetWidth(326);
	g_BBar.RepScrollFrame:Hide();	-- Initially hidden

	-- Currencies scroll window
	g_BBar.CurrencyScrollFrame = CreateFrame("ScrollFrame", "CurrencyScrollFrame", _G["BBarSettingsFrame"], "UIPanelScrollFrameTemplate");
	g_BBar.CurrencyScrollFrame:SetPoint("TOPLEFT", _G["BBarSettingsFrame"], "TOPLEFT", 14, -80);
	g_BBar.CurrencyScrollFrame:SetPoint("BOTTOMRIGHT", _G["BBarSettingsFrame"], "BOTTOMRIGHT", -31, 37);

	scrollChild = CreateFrame("Frame", "BBarScrollFrameChild", g_BBar.CurrencyScrollFrame);
	scrollChild:EnableMouse(true)
	scrollChild:SetWidth(326);

	local scrollChildHeight = 0;
	local priorItem = scrollChild;

	-- Currencies
	for i = 1, g_BBar.TOTALITEMS, 1 do
		if(g_BBar.BBarObjects[i] < g_BBar.MINCURRENCYID) then
			if(g_BBar.BBarObjects[i] == 1) then
				priorItem = BBar_CreateSettingsItem("Money", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 2) then
				priorItem = BBar_CreateSettingsItem("Points", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 3) then
				priorItem = BBar_CreateSettingsItem("Professions", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 4) then
				priorItem = BBar_CreateSettingsItem("Items", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 5) then
				priorItem = BBar_CreateSettingsItem("Archaeology", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 6) then
				priorItem = BBar_CreateSettingsItem("Custom Items", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			end
		elseif (g_BBar.BBarObjects[i] > g_BBar.MINCURRENCYID) then
			local name, count, icon;
			if(g_BBar.BBarObjects[i] == g_BBar.MONEYID) then
				name = "Character Gold";
				count = 0;
				icon = "Interface\\MoneyFrame\\UI-MoneyIcons";
			else
				name, count, icon = GetCurrencyInfo(g_BBar.BBarObjects[i]);
			end
			priorItem = BBar_CreateSettingsItem(name, icon, scrollChild, priorItem, i);
			priorItem.currencyID = g_BBar.BBarObjects[i];
			scrollChildHeight = scrollChildHeight + 24;
		end
	end

	-- Store some values for use when we add the custom items
	g_BBar.lastSettingsItem = priorItem;
	g_BBar.defaultSettingsheight = scrollChildHeight;

	scrollChild:SetHeight(scrollChildHeight);
	g_BBar.CurrencyScrollFrame:SetScrollChild(scrollChild);
end


function BBar_UpdateSettings(self)		-- Called each time the window is shown

-- Set the options check boxes
	if(BBarWindowLock > 0) then
		_G["BBarSettingsFrameLockCheck"]:SetChecked(true);
	else
		_G["BBarSettingsFrameLockCheck"]:SetChecked(false);
	end
	if(BBarShowTooltip > 0) then
		_G["BBarSettingsFrameTooltipCheck"]:SetChecked(true);
	else
		_G["BBarSettingsFrameTooltipCheck"]:SetChecked(false);
	end

-- Set the check boxes depending on if they are shown
	for i = 1, g_BBar.TOTALITEMS, 1 do
		if(g_BBar.BBarObjects[i] > g_BBar.MINCURRENCYID and g_BBar.BBarObjects_Shown[i] > 0) then
			_G["BBarSettingsItem"..i.."Check"]:SetChecked(true);
		else
			_G["BBarSettingsItem"..i.."Check"]:SetChecked(false);
		end
	end

	-- Custom items
	local scrollChild = _G["BBarScrollFrameChild"];
	local priorItem = g_BBar.lastSettingsItem;
	local scrollChildHeight = g_BBar.defaultSettingsheight;

	local name = "";
	local icon = "";
	local numAdded = 0;
	for i = 1, getn(g_BBar.BBarObjectsItems), 1 do
		if(g_BBar.BBarObjectsItems[i] > 0) then
			name = GetItemInfo(g_BBar.BBarObjectsItems[i]);
			icon = GetItemIcon(g_BBar.BBarObjectsItems[i]);
		end
		local returnItem = BBar_CreateSettingsItem(name, icon, scrollChild, priorItem, i + 100);
		if(returnItem ~= priorItem) then
			priorItem = returnItem;
			priorItem.currencyID = -g_BBar.BBarObjectsItems[i];
			scrollChildHeight = scrollChildHeight + 30;
			if(g_BBar.BBarObjectsItems_Shown[i] > 0) then
				_G["BBarSettingsItem"..(i + 100).."Check"]:SetChecked(true);
			else
				_G["BBarSettingsItem"..(i + 100).."Check"]:SetChecked(false);
			end
			numAdded = numAdded + 1;
		end
	end
	-- Add 'No custom items' text if needed
	local returnItem = BBar_CreateSettingsItem("No custom items", "", scrollChild, priorItem, 100);
	if(numAdded == 0) then
		returnItem:Show();
		scrollChildHeight = scrollChildHeight + 30;
	else	returnItem:Hide();
	end
	scrollChild:SetHeight(scrollChildHeight);

	-- Also load/Update the reputations
	BBar_BuildReputationFrame();
end


function BBar_BuildReputationFrame()	-- Create/update the settings reputation window

	ExpandAllFactionHeaders();	-- Make everything visable to me

	local scrollChild = _G["BBarScrollFrameChildRep"];
	local scrollChildHeight = 0;
	local priorItem = scrollChild;

	-- Reputations
	local priorName = "";
	for i = 1, 200, 1 do

	-- Get the data
		local name, _, standingID, barMin, barMax, barValue, _, _, isHeader, isCollapsed, hasRep, _, isChild, factionID = GetFactionInfo(i);
		if((name == nil) or (name == priorName) or (name == "Other"))	then	break	end;	-- last one reached
		priorName = name;

	-- Create the bar
		local factionRow = _G["BBarSettingsRep"..i];
		if( not factionRow ) then
			factionRow = CreateFrame("Frame", "BBarSettingsRep"..i, scrollChild, "BBarSettingsRepTemplate");
		end
		local factionBar =			_G["BBarSettingsRep"..i.."RepBar"];
		local factionTitle =		_G["BBarSettingsRep"..i.."FactionName"];
		local factionCheck =		_G["BBarSettingsRep"..i.."Check"];
		local factionBarFill =		_G["BBarSettingsRep"..i.."RepBarPercentageBar"];
		local factionStanding =		_G["BBarSettingsRep"..i.."RepBarStanding"];

		-- The first item needs to be setup relative to the scroll child
		factionRow:ClearAllPoints();
		if(i == 1) then	factionRow:SetPoint("TOP", scrollChild, "TOP", 0, 0);
		else			factionRow:SetPoint("TOPLEFT", priorItem, "BOTTOMLEFT", 0, 0);
		end
		priorItem = factionRow;
		scrollChildHeight = scrollChildHeight + 22;

	-- Fill it
		factionTitle:SetText(name);
		local factionStandingtext = GetText("FACTION_STANDING_LABEL"..standingID, UnitSex("player"));

		-- Check if this is a friendship faction (members of the Tillers)
		local friendID, _, friendMaxRep, _, _, friendTextLevel, friendThresh = GetFriendshipReputationByID(factionID);
		if(friendID ~= nil) then
	--	_T(name.."  "..tostring(friendRep).."  "..tostring(friendMaxRep).."  "..tostring(friendText).."  "..tostring(friendThresh));
			factionStandingtext = friendTextLevel;
			barMax = friendMaxRep - friendThresh;
			barValue = barValue - friendThresh;
		else
	--	_T(name.."  "..tostring(barMax).."  "..tostring(barValue).."  "..tostring(barMin));
			barMax = barMax - barMin;
			barValue = barValue - barMin;
			if(barValue < 0) then	barValue = (barMax - barValue);	end
		end
		if(barValue == 0) then
				factionBarFill:Hide();	-- Supplying 0 causes max size
		else	factionBarFill:SetWidth((factionBar:GetWidth() / abs(barMax)) * abs(barValue));
		end

		-- Store for later use
		factionBar.standingtext = factionStandingtext;
		factionBar.reptext = tostring(barValue).."/"..tostring(barMax);
		factionRow.factionID = factionID;
		factionRow.pos = i;
		
		factionStanding:SetText(factionStandingtext);
		local color = FACTION_BAR_COLORS[standingID];
		factionBarFill:SetVertexColor(color.r, color.g, color.b, 0.5);

		if(isHeader) then
			factionTitle:SetFontObject(GameFontNormalLeft);
			factionRow:SetHeight(16 + 12);	-- Base + extra
		else
			local point, relativeTo, relativePoint, xOfs, yOfs = factionTitle:GetPoint();
			factionTitle:SetPoint(point, relativeTo, relativePoint, 12, yOfs);
		end
		if(hasRep or (not isHeader)) then
			factionStanding:Show();
			factionBar:Show();
			factionCheck:Show();
		else
			factionStanding:Hide();
			factionBar:Hide();
			factionCheck:Hide();
		end
		if(g_BBar.BBarObjectsReps_Faction[i] and (g_BBar.BBarObjectsReps_Faction[i][2] > 0)) then
			factionCheck:SetChecked(true);
		else
			factionCheck:SetChecked(false);
		end
	end

	scrollChild:SetHeight(scrollChildHeight);
	g_BBar.RepScrollFrame:SetScrollChild(scrollChild);
end


function BBar_CreateSettingsItem(name, icon, parent, priorItem, iPos)

	-- If this item doesn't exist yet, create it
	local item = _G["BBarSettingsItem"..iPos];
	if( not item ) then
		item = CreateFrame("Frame", "BBarSettingsItem"..iPos, parent, "BBarSettingsItemTemplate");
	else	item:ClearAllPoints();
	end
	local textItem = _G[item:GetName().."Text"];
	textItem:SetText(name);

	local obj = -1;		-- Custom item
	if(iPos < 100) then	obj = g_BBar.BBarObjects[iPos];	end

	if(iPos == 100) then	-- Special text only item (not title, e.g. "No custom items")
		_G[item:GetName().."Icon"]:Hide();
		_G[item:GetName().."Check"]:Hide();
		_G[item:GetName().."Remove"]:Hide();
	elseif(obj > 0 and obj < g_BBar.MINCURRENCYID) then		-- Title
		textItem:SetPoint("TOPLEFT", 26, -6);	-- Move the text down
		textItem:SetWidth(260);					-- Widen it for proper spacing
		textItem:SetJustifyH("CENTER");
		textItem:SetTextColor(0.8, 1, 0.7, 1);
		_G[item:GetName().."Check"]:Hide();
		_G[item:GetName().."Remove"]:Hide();

		if(obj == 1) then	-- The first item needs to be setup relative to the scroll child
			item:SetPoint("TOP", parent, "TOP", 0, 4);
			return item;
		end
	else
		if(obj < 0) then	-- Custom item!
			if(g_BBar.BBarObjectsItems[iPos - 100] > 0) then	-- Only show valid ones
				local _, _, itemQuality = GetItemInfo(g_BBar.BBarObjectsItems[iPos - 100]);
				if(itemQuality ~= nil) then		textItem:SetTextColor(GetItemQualityColor(itemQuality));	end
				_G[item:GetName().."Icon"]:SetTexture(icon);
				_G[item:GetName().."Check"]:Show();
				_G[item:GetName().."Remove"]:Show();
			else
				item:Hide();
				return priorItem;	-- Skip it
			end
		else				-- Currency
			local tex = _G[item:GetName().."Icon"];
			if(obj == g_BBar.MONEYID) then
					tex:SetTexture(icon);
					tex:SetWidth(20);
					tex:SetHeight(20);
					tex:SetTexCoord(0, 0.25, 0, 1);
			else	tex:SetTexture("Interface\\Icons\\"..icon);
			end
			_G[item:GetName().."Check"]:Show();
			_G[item:GetName().."Remove"]:Hide();
		end
		item.positionID = iPos;
	end
	item:SetPoint("TOPLEFT", priorItem, "BOTTOMLEFT", 0, -4);
	return item;
end

